com.orsoncharts.data

## Class KeyedValues3DItemKey<S extends java.lang.Comparable<S>,R extends java.lang.Comparable<R>,C extends java.lang.Comparable<C>>

- java.lang.Object
- - com.orsoncharts.data.KeyedValues3DItemKey<S,R,C>

- All Implemented Interfaces:
    ItemKey, java.io.Serializable, java.lang.Comparable<KeyedValues3DItemKey<S,R,C>>

      public class KeyedValues3DItemKey<S extends java.lang.Comparable<S>,R extends java.lang.Comparable<R>,C extends java.lang.Comparable<C>>
      extends java.lang.Object
      implements ItemKey, java.lang.Comparable<KeyedValues3DItemKey<S,R,C>>, java.io.Serializable

  An object that references one data item in a `KeyedValues3D` data structure. Instances of this class are immutable (subject to the caller using series, row and column keys that are immutable).
  Since:
    1.3
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `KeyedValues3DItemKey(S seriesKey, R rowKey, C columnKey)` Creates a new instance.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compareTo(KeyedValues3DItemKey<S,R,C> key)`
    `boolean` | `equals(java.lang.Object obj)` Tests this key for equality with an arbitrary object.
    `C` | `getColumnKey()` Returns the column key.
    `R` | `getRowKey()` Returns the row key.
    `S` | `getSeriesKey()` Returns the series key.
    `int` | `hashCode()`
    `java.lang.String` | `toJSONString()` Returns a JSON formatted string representing the key.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### KeyedValues3DItemKey

          public KeyedValues3DItemKey(S seriesKey,
                                      R rowKey,
                                      C columnKey)

      Creates a new instance.
      Parameters:
        `seriesKey` - the series key (`null` not permitted).
        `rowKey` - the row key (`null` not permitted).
        `columnKey` - the column key (`null` not permitted).

  - ### Method Detail

    - #### getSeriesKey

          public S getSeriesKey()

      Returns the series key.
      Returns:
        The series key (never `null`).

    - #### getRowKey

          public R getRowKey()

      Returns the row key.
      Returns:
        The row key (never `null`).

    - #### getColumnKey

          public C getColumnKey()

      Returns the column key.
      Returns:
        The column key (never `null`).

    - #### compareTo

          public int compareTo(KeyedValues3DItemKey<S,R,C> key)

      Specified by:
        `compareTo` in interface `java.lang.Comparable<KeyedValues3DItemKey<S extends java.lang.Comparable<S>,R extends java.lang.Comparable<R>,C extends java.lang.Comparable<C>>>`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Tests this key for equality with an arbitrary object.
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `obj` - the object (`null` permitted).
      Returns:
        A boolean.

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### toJSONString

          public java.lang.String toJSONString()

      Description copied from interface: `ItemKey`
      Returns a JSON formatted string representing the key.
      Specified by:
        `toJSONString` in interface `ItemKey`
      Returns:
        A JSON formatted string.

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`